//////////////////////////////////////////////////////////////////////////////////////////////////////  
//
// WIRELESS MOUSETRAP MONITORING SYSTEM by Alberto Ricci Bitti (c) 2003      www.riccibitti.com
//
//////////////////////////////////////////////////////////////////////////////////////////////////////  

#ifndef TRAP_INCLUDED
#define TRAP_INCLUDED

#include "radio.h"

#define NUM_MEMORIES 20
#define INDEX_NONE NUM_MEMORIES
#define TRAP_HEARTBEAT_TIME       6 //after 6 hours without receiving trap signal, trap is deemed lost
#define ID_NONE 0

typedef struct {
    unsigned char trigger  : 1; // trap is triggered
    unsigned char battery  : 1; // trap low battery flag
    unsigned char test     : 1; // trap is in test/reduced power mode
    unsigned char timer    : 5; // measures time from last reception
} T_TRAP_DESCRIPTOR;

extern T_TRAP_DESCRIPTOR trap[ NUM_MEMORIES ];

#pragma CONST_SEG FLASH_EEPROM 
extern const unsigned int trap_ID[ NUM_MEMORIES ];
#pragma CONST_SEG DEFAULT 

extern void          trap_initialize( void );
extern void          trap_store_ID  (unsigned int ID, unsigned char index);
extern void          trap_update    ( T_RADIO_DATA radio );
extern void          trap_clear     ( unsigned char index );
extern unsigned char trap_next      ( unsigned char index );
extern unsigned char trap_prev      ( unsigned char index );
extern unsigned char trap_is_free   ( unsigned char index );
extern unsigned char next_yelling   ( unsigned char index );
extern unsigned char is_ID_new      ( unsigned int ID );
extern unsigned char ID_to_index    ( unsigned int ID );
extern void          heartbeat      ( void );


#endif