/*************************************************************************/
/* Pseudo-Vector table - For the user mode monitor only.                 */
/*                                                                       */
/* This table is valid if the user-mode monitor has been programmed into */
/* the DEMO board supplied by Motorola. For normal modes of the device   */
/* a different table is used and can be seen in the standard QT/QY demo  */
/* applications.                                                         */
/*                                                                       */
/* This table allows the user to control three major aspects of the QT4: */
/*                                                                       */
/* (1) The default value of the CONFIG1 register                         */
/* (2) The locations of all the interrupt routines.                      */
/* (2) The location of the routine to run upon reset.                    */
/*************************************************************************/


void _ADC_Interrupt(void);
void _KBD_Interrupt(void);
void _TOF_Interrupt(void);
void _TCH1_Interrupt(void);
void _TCH0_Interrupt(void);
void _IRQ_Interrupt(void);
void _Startup(void);

#define CONFIG1_VAL  0x3D      /* user value for CONFIG1 */

#define CONFIG1_ADR  0xFDEA    /* address of user value for CONFIG1 */
#define JMP_TAB_ADR  0xFDEB    /* address of jump table */
#define JMP_Code     0xCC      /* opcode of JMP instruction */

typedef void (*tIntFunc)(void);

typedef struct jumpEntry {
   unsigned char jmpIstr;
   tIntFunc      intFunc;
} JumpEntry;

const unsigned char CONFIG1 @CONFIG1_ADR = CONFIG1_VAL;

const JumpEntry IntJmpTable[] @JMP_TAB_ADR = {     /* table of JMP instructions to interrupt routines */
           JMP_Code, _ADC_Interrupt,
           JMP_Code, _KBD_Interrupt,
           JMP_Code, _TOF_Interrupt,
           JMP_Code, _TCH1_Interrupt,
           JMP_Code, _TCH0_Interrupt,
           JMP_Code, _IRQ_Interrupt,
           JMP_Code, _Startup 
};