//////////////////////////////////////////////////////////////////////////////////////////////////////  
//
// WIRELESS MOUSETRAP MONITORING SYSTEM by Alberto Ricci Bitti (c) 2003      www.riccibitti.com
//
//////////////////////////////////////////////////////////////////////////////////////////////////////  
//
// MODULE:   WAIT.C
// PURPOSE:  Provides wait primitives based on ROM routines
// REQUIRES: Works only on HC908QT/QY
//           see also: AN2346, AN1831 for ROM information
// NOTES:    Times are intended to be MINIMUM times, actual time can be longer!!!
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "wait.h"

#define DELNUS 0x280C       /*ROM routine address for delay*/



///////////////////////////////////////////////////////////////////////////////
// wait_x12_uS - wait the specified number of 12 uS units                    //
///////////////////////////////////////////////////////////////////////////////

void wait_x12_uS( unsigned char n )
{
    _asm ldx n;             //X = number of 12 uS units
    _asm lda 13;            //CPU CLOCK / 250 kHz = 13
    _asm jsr DELNUS;        //call ROM delay routine
}



///////////////////////////////////////////////////////////////////////////////
// wait_mS - wait the specified number of mS                                 //
///////////////////////////////////////////////////////////////////////////////

void wait_mS( unsigned int n )
{
    while( n--)
        wait_x12_uS( 84 );  // 1000 uS / 12 uS = 84
}